﻿Public Class Form1
    
    Dim rowbegin As Integer, columnbegin As Integer
    Dim direction As String
    Dim ctrlpressed As Boolean = False
    Dim celldrag As Boolean = False

    Private Sub CopyCellsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyCellsToolStripMenuItem.Click
        'Copy complete cell along with formatting
        Dim cell As FarPoint.Win.Spread.Cell = FpSpread1.ActiveSheet.Cells(rowbegin, columnbegin)
        If direction = "Down" Then
            For i As Integer = rowbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin) - 1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = cell.Value
                copyFormat(i, columnbegin, cell)
            Next
        ElseIf direction = "Up" Then
            For i As Integer = rowbegin - 1 To (rowbegin - FpSpread1.ActiveSheet.GetSelection(0).RowCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = cell.Value
                copyFormat(i, columnbegin, cell)
            Next

        ElseIf direction = "Right" Then
            For i As Integer = columnbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin) - 1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = cell.Value
                copyFormat(rowbegin, i, cell)
            Next

        ElseIf direction = "Left" Then
            For i As Integer = columnbegin - 1 To (columnbegin - FpSpread1.ActiveSheet.GetSelection(0).ColumnCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = cell.Value
                copyFormat(rowbegin, i, cell)
            Next
        End If
    End Sub

    Private Sub FillSeriesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillSeriesToolStripMenuItem.Click
        'Fill Series i.e. Auto Increment/Decrement
        Dim num As Integer = Convert.ToInt32(FpSpread1.ActiveSheet.Cells(rowbegin, columnbegin).Value)
        Dim j As Integer = 1
        If direction = "Down" Then
            For i As Integer = rowbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin) - 1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = num + j
                j += 1
            Next

        ElseIf direction = "Up" Then
            For i As Integer = rowbegin - 1 To (rowbegin - FpSpread1.ActiveSheet.GetSelection(0).RowCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = num - j
                j += 1
            Next

        ElseIf direction = "Right" Then
            For i As Integer = columnbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin) - 1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = num + j
                j += 1
            Next

        ElseIf direction = "Left" Then
            For i As Integer = columnbegin - 1 To (columnbegin - FpSpread1.ActiveSheet.GetSelection(0).ColumnCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = num - j
                j += 1
            Next
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Allowing drag and fill for spread
        FpSpread1.AllowDragFill = True
    End Sub

    Private Sub FillFormattingOnlyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillFormattingOnlyToolStripMenuItem.Click
        'Copying only formatting
        Dim cell As FarPoint.Win.Spread.Cell = FpSpread1.ActiveSheet.Cells(rowbegin, columnbegin)
        If direction = "Down" Then
            For i As Integer = rowbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin) - 1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = Nothing
                copyFormat(i, columnbegin, cell)
            Next
        ElseIf direction = "Up" Then
            For i As Integer = rowbegin - 1 To (rowbegin - FpSpread1.ActiveSheet.GetSelection(0).RowCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = Nothing
                copyFormat(i, columnbegin, cell)
            Next

        ElseIf direction = "Right" Then
            For i As Integer = columnbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin) - 1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = Nothing
                copyFormat(rowbegin, i, cell)
            Next

        ElseIf direction = "Left" Then
            For i As Integer = columnbegin - 1 To (columnbegin - FpSpread1.ActiveSheet.GetSelection(0).ColumnCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = Nothing
                copyFormat(rowbegin, i, cell)
            Next
        End If
    End Sub

    Private Sub FillWithoutFormattingToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillWithoutFormattingToolStripMenuItem.Click
        'copying only formatting not data
        Dim cell As FarPoint.Win.Spread.Cell = FpSpread1.ActiveSheet.Cells(rowbegin, columnbegin)
        If direction = "Down" Then
            For i As Integer = rowbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).RowCount + rowbegin) - 1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = cell.Value
                NoFormat(i, columnbegin)
            Next
        ElseIf direction = "Up" Then
            For i As Integer = rowbegin - 1 To (rowbegin - FpSpread1.ActiveSheet.GetSelection(0).RowCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(i, columnbegin).Value = cell.Value
            Next

        ElseIf direction = "Right" Then
            For i As Integer = columnbegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).ColumnCount + columnbegin) - 1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = cell.Value
            Next

        ElseIf direction = "Left" Then
            For i As Integer = columnbegin - 1 To (columnbegin - FpSpread1.ActiveSheet.GetSelection(0).ColumnCount) + 1 Step -1
                FpSpread1.ActiveSheet.Cells(rowbegin, i).Value = cell.Value
            Next
        End If
    End Sub

    Private Sub ContextMenuStrip1_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ContextMenuStrip1.Opening
        ' to disable the Menustrip if no cell is dragging is performed
        If FpSpread1.ActiveSheet.GetSelection(0).ColumnCount = 1 AndAlso FpSpread1.ActiveSheet.GetSelection(0).RowCount = 1 Then
            e.Cancel = True
        End If
    End Sub

    Private Sub FpSpread1_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles FpSpread1.KeyUp
        ctrlpressed = False
    End Sub

    Private Sub FpSpread1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles FpSpread1.KeyDown
        ' to check whether CTRL key is pressed or not
        If e.KeyCode = Keys.ControlKey Then
            ctrlpressed = True
        End If
    End Sub

    Private Sub FpSpread1_DragFillBlockCompleted(ByVal sender As System.Object, ByVal e As FarPoint.Win.Spread.DragFillBlockCompletedEventArgs) Handles FpSpread1.DragFillBlockCompleted
        'For implementing second requirement i.e. Auto increment/decrement by drag with CTRL key
        If ctrlpressed = True AndAlso celldrag = True Then
            Dim num As Integer = Convert.ToInt32(FpSpread1.ActiveSheet.Cells(e.RowBegin, e.ColumnBegin).Value)
            Dim cell As FarPoint.Win.Spread.Cell = FpSpread1.ActiveSheet.Cells(e.RowBegin, e.ColumnBegin)
            Dim j As Integer = 1
            If e.Direction = FarPoint.Win.Spread.FillDirection.Down Then
                For i As Integer = e.RowBegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).RowCount + e.RowBegin) - 1
                    FpSpread1.ActiveSheet.Cells(i, e.ColumnBegin).Value = num + j
                    copyFormat(i, e.ColumnBegin, cell)
                    j += 1
                Next

            ElseIf e.Direction = FarPoint.Win.Spread.FillDirection.Up Then
                For i As Integer = e.RowBegin - 1 To (e.RowBegin - FpSpread1.ActiveSheet.GetSelection(0).RowCount) + 1 Step -1
                    FpSpread1.ActiveSheet.Cells(i, e.ColumnBegin).Value = num - j
                    copyFormat(i, e.ColumnBegin, cell)
                    j += 1
                Next

            ElseIf e.Direction = FarPoint.Win.Spread.FillDirection.Right Then
                For i As Integer = e.ColumnBegin + 1 To (FpSpread1.ActiveSheet.GetSelection(0).ColumnCount + e.ColumnBegin) - 1
                    FpSpread1.ActiveSheet.Cells(e.RowBegin, i).Value = num + j
                    copyFormat(e.RowBegin, i, cell)
                    j += 1
                Next

            ElseIf e.Direction = FarPoint.Win.Spread.FillDirection.Left Then
                For i As Integer = e.ColumnBegin - 1 To (e.ColumnBegin - FpSpread1.ActiveSheet.GetSelection(0).ColumnCount) + 1 Step -1
                    FpSpread1.ActiveSheet.Cells(e.RowBegin, i).Value = num - j
                    copyFormat(e.RowBegin, i, cell)
                    j += 1
                Next
            End If
        Else
            celldrag = False
            rowbegin = e.RowBegin
            columnbegin = e.ColumnBegin
            direction = e.Direction.ToString()
            CopyCellsToolStripMenuItem_Click(Nothing, Nothing)
        End If
    End Sub

    Private Sub FpSpread1_DragFillBlock(ByVal sender As System.Object, ByVal e As FarPoint.Win.Spread.DragFillBlockEventArgs) Handles FpSpread1.DragFillBlock
        FpSpread1.ContextMenuStrip = ContextMenuStrip1
        celldrag = True
    End Sub

    Private Sub NoFormat(ByVal row As Integer, ByVal col As Integer)
        'Copying the formatting of cell
        fpSpread1.ActiveSheet.Cells(row, col).BackColor = System.Drawing.Color.Transparent
        fpSpread1.ActiveSheet.Cells(row, col).ForeColor = System.Drawing.Color.Black
        fpSpread1.ActiveSheet.Cells(row, col).Font = New System.Drawing.Font("Microsoft Sans Serif", 7.8F)
    End Sub

    Private Sub copyFormat(ByVal row As Integer, ByVal col As Integer, ByVal cell As FarPoint.Win.Spread.Cell)
        'Copying the formatting of cell
        FpSpread1.ActiveSheet.Cells(row, col).BackColor = cell.BackColor
        FpSpread1.ActiveSheet.Cells(row, col).ForeColor = cell.ForeColor
        FpSpread1.ActiveSheet.Cells(row, col).Font = cell.Font
    End Sub
End Class
